//+------------------------------------------------------------------+
//|                                               Indicator_test.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
//---- parameters
extern double    TakeProfit = 100.0;
extern double    StopLoss = 75.0;
extern int       ShortEma = 5;
extern int       LongSma = 20;
extern int       SecondShortEma = 5;
extern int       SecondLongEma = 20;

extern double    Lots = 0.1;
extern int openbar;
//extern double    TrailingStop = 35.0;
//extern double    Modificator = 1.0;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }

int FirstCrossed (double line_fast, double line_slow)
   {
      int last_direction = 0;
      int current_direction = 0;
      
      if(line_fast > line_slow) //up
         current_direction = 1;
      if (line_fast < line_slow) //down
         current_direction = 2;  
      if (current_direction != last_direction) //changed
         {
         last_direction = current_direction;
         return(last_direction);
         }
      else 
         {
            return(0);
         }
   }

int SecondCrossed (double medium_line, double very_slow_line)
    {
      int last_direction = 0;
      int current_direction = 0;
      
      if(medium_line > very_slow_line) //up
         current_direction = 1;
      if (medium_line < very_slow_line) //down
         current_direction = 2;  
      if (current_direction != last_direction) //changed
         {
         last_direction = current_direction;
            return(last_direction);
         }
      else 
         {
            return(0);
         }
   }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
 
int start()
  {

         int ticket, total, cnt, closebar;
         double SEma, LSma, SSEma, SLEma ;
         
         
         if(Bars < 100)
           {
             Print("bars less than 100");
             return(0);  
           }

         SEma = iMA(NULL, PERIOD_H1, ShortEma, 0, MODE_EMA, PRICE_CLOSE, 0);// First Short EMA
         LSma = iMA(NULL, PERIOD_H1, LongSma, 0, MODE_EMA, PRICE_CLOSE, 0); // First Long EMA 
         SSEma = iMA(NULL, PERIOD_H4, SecondShortEma, 0, MODE_EMA, PRICE_CLOSE, 0); // Second Short EMA
         SLEma = iMA(NULL, PERIOD_H4, SecondLongEma, 0, MODE_EMA, PRICE_CLOSE, 0);  // Second Long EMA
         
        int firstCross = FirstCrossed (SEma, LSma);
        int secondCross = SecondCrossed (SSEma, SLEma);
               
     total  = OrdersTotal(); 
     //Print("CHECK TOTAL < 1 ");
    
     closebar = Bars;     
     if(total < 1) 
      {
         //Print("FIRST CROSS 1 AND SECOND CROSS 1 ");
         if(firstCross == 1)//if First and Second are up , && secondCross == 1
               {
                 ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, 3, 0, 0, "Order Buy", 12345, 0, Green);//Ask - StopLoss*Point, Ask + TakeProfit*Point,
                 Print("TICKET BUY IS : ",OrderOpenPrice()," BARS : ",Bars);
                 openbar = Bars + 10;
                 
                 
                        if(ticket > 0)
                          {
                            if(OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES))
                                Print("BUY order opened : ",OrderOpenPrice());
                          }
                        else 
                            Print("Error opening BUY order : ", GetLastError()); 
                            return(0);
                                                           
             }
           //Print("FIRST CROSS 2 AND SECOND CROSS 2 ");
          if(firstCross == 2)// if Period First and Second are down , && secondCross == 2
               {       
                  ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, 3, 0, 0, "Order Sell", 12345, 0, Blue);//Bid + StopLoss*Point, Bid - TakeProfit*Point,
                  Print("TICKET SELL IS : ",OrderOpenPrice()," BARS : ",Bars);                 
                  openbar = Bars + 10;
                          if(ticket > 0)
                            {
                              if(OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) 
                                  Print("SELL order opened : ", OrderOpenPrice());
                            }
                          else
                              Print("Error opening SELL order : ",GetLastError()); 
                               return(0);
                                                 
               }               
      }      
//----------------------------------------------------------------------------------------------------------------------------------------------
    
    for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL && OrderSymbol()==Symbol())
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
           // should it be closed 
              if(firstCross == 2)
                {
                   //Close, check if next 10 bar's printed after OpenOrderPrise()
                   if(openbar <= closebar)
                     {
                        OrderClose(OrderTicket(),OrderLots(),Bid,3,Red); // close position
                        return(0); // exit
                     }else
                     return(0);   
                }    
           }
         else // go to short position
           {
            // should it be closed
            if(firstCross == 1)
              {
               //Close, check if next 10 bar's printed after OpenOrderPrise()
               if(openbar <= closebar)
                  {
                     OrderClose(OrderTicket(),OrderLots(),Ask,3,Red); // close position                  
                     return(0); // exit
                  }else
                   return(0);          
              }
           }
        }
     }
//----------------------------------------------------------------------------------------------------------------------------------------------
   return(0);
  }
//+------------------------------------------------------------------+